"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.do_dot = void 0;
const Exp = __importStar(require("../exp"));
const Value = __importStar(require("../value"));
const Neutral = __importStar(require("../neutral"));
const Telescope = __importStar(require("../telescope"));
const Trace = __importStar(require("../../trace"));
const ut = __importStar(require("../../ut"));
function do_dot(target, name) {
    if (target.kind === "Value.obj") {
        const value = target.properties.get(name);
        if (value === undefined) {
            throw new Trace.Trace(ut.aline(`
          |the property name ${name} is undefined.
          |`));
        }
        return value;
    }
    else if (target.kind === "Value.cls") {
        const { sat, tel } = target;
        for (const entry of sat) {
            if (entry.name === name) {
                return entry.t;
            }
        }
        return Telescope.dot(tel, name);
    }
    else if (target.kind === "Value.not_yet") {
        if (target.t.kind === "Value.cls") {
            return Value.not_yet(Telescope.dot(target.t.tel, name), Neutral.dot(target.neutral, name));
        }
        else {
            throw new Trace.Trace(Exp.explain_elim_target_type_mismatch({
                elim: "dot",
                expecting: ["Value.cls"],
                reality: target.t.kind,
            }));
        }
    }
    else {
        throw new Trace.Trace(Exp.explain_elim_target_mismatch({
            elim: "dot",
            expecting: ["Value.obj", "Value.cls", "Value.not_yet"],
            reality: target.kind,
        }));
    }
}
exports.do_dot = do_dot;
