import * as Stmt from "../stmt";
export declare type Exp = v | pi | fn | ap | cls | fill | obj | dot | equal | same | replace | absurd | absurd_ind | str | quote | union | type | begin | the;
export interface v {
    kind: "Exp.v";
    name: string;
}
export declare const v: (name: string) => v;
export interface pi {
    kind: "Exp.pi";
    name: string;
    arg_t: Exp;
    ret_t: Exp;
}
export declare const pi: (name: string, arg_t: Exp, ret_t: Exp) => pi;
export interface fn {
    kind: "Exp.fn";
    name: string;
    ret: Exp;
}
export declare const fn: (name: string, ret: Exp) => fn;
export interface ap {
    kind: "Exp.ap";
    target: Exp;
    arg: Exp;
}
export declare const ap: (target: Exp, arg: Exp) => ap;
export interface cls {
    kind: "Exp.cls";
    sat: Array<{
        name: string;
        t: Exp;
        exp: Exp;
    }>;
    scope: Array<{
        name: string;
        t: Exp;
    }>;
}
export declare const cls: (sat: Array<{
    name: string;
    t: Exp;
    exp: Exp;
}>, scope: Array<{
    name: string;
    t: Exp;
}>) => cls;
export interface fill {
    kind: "Exp.fill";
    target: Exp;
    arg: Exp;
}
export declare const fill: (target: Exp, arg: Exp) => fill;
export interface obj {
    kind: "Exp.obj";
    properties: Map<string, Exp>;
}
export declare const obj: (properties: Map<string, Exp>) => obj;
export interface dot {
    kind: "Exp.dot";
    target: Exp;
    name: string;
}
export declare const dot: (target: Exp, name: string) => dot;
export interface equal {
    kind: "Exp.equal";
    t: Exp;
    from: Exp;
    to: Exp;
}
export declare const equal: (t: Exp, from: Exp, to: Exp) => equal;
export interface same {
    kind: "Exp.same";
}
export declare const same: same;
export interface replace {
    kind: "Exp.replace";
    target: Exp;
    motive: Exp;
    base: Exp;
}
export declare const replace: (target: Exp, motive: Exp, base: Exp) => replace;
export interface absurd {
    kind: "Exp.absurd";
}
export declare const absurd: absurd;
export interface absurd_ind {
    kind: "Exp.absurd_ind";
    target: Exp;
    motive: Exp;
}
export declare const absurd_ind: (target: Exp, motive: Exp) => absurd_ind;
export interface str {
    kind: "Exp.str";
}
export declare const str: str;
export interface quote {
    kind: "Exp.quote";
    str: string;
}
export declare const quote: (str: string) => quote;
export interface union {
    kind: "Exp.union";
    left: Exp;
    right: Exp;
}
export declare const union: (left: Exp, right: Exp) => union;
export interface type {
    kind: "Exp.type";
}
export declare const type: type;
export interface begin {
    kind: "Exp.begin";
    stmts: Array<Stmt.Stmt>;
    ret: Exp;
}
export declare const begin: (stmts: Array<Stmt.Stmt>, ret: Exp) => begin;
export interface the {
    kind: "Exp.the";
    t: Exp;
    exp: Exp;
}
export declare const the: (t: Exp, exp: Exp) => the;
